diff a/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Ternary-Masked-op.template b/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Ternary-Masked-op.template
--- /dev/null
+++ b/test/jdk/jdk/incubator/vector/templates/Perf-Scalar-Ternary-Masked-op.template
@@ -0,0 +1,23 @@
+
+    @Benchmark
+    public void [[TEST]][[TEST_TYPE]][[OP_NAME]](Blackhole bh) {
+        $type$[] as = fa.apply(size);
+        $type$[] bs = fb.apply(size);
+        $type$[] cs = fc.apply(size);
+        $type$[] rs = fr.apply(size);
+        boolean[] ms = fm.apply(size);
+
+        for (int ic = 0; ic < INVOC_COUNT; ic++) {
+            for (int i = 0; i < as.length; i++) {
+                $type$ a = as[i];
+                $type$ b = bs[i];
+                $type$ c = cs[i];
+                if (ms[i % ms.length]) {
+                    rs[i] = ($type$)([[TEST_OP]]);
+                } else {
+                    rs[i] = a;
+                }
+            }
+        }
+        bh.consume(rs);
+    }
